unit code; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons;

type

  { TfrmMain }

  TfrmMain = class(TForm)
    Button1: TButton;
    pa: TPanel;
    procedure PMouseDownEcke(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PMouseMoveEcke(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PMouseUpEcke(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PMouseDownMitte(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PMouseMoveMitte(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PMouseUpMitte(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure paMouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure paMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure paMouseUp(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { private declarations }
    c    : Integer; // Zum ermitteln des aktuellen Punktes
    MPos : TPoint;  // Mouseposition
    Flag : Boolean;
  public
    { public declarations }
  end; 

var
  frmMain: TfrmMain;

implementation

{ TfrmMain }

// Ecke
procedure TfrmMain.PMouseDownEcke(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Flag   := True;

  MPos.X := pa.Left + X;
  MPos.Y := pa.Top + Y;
end;

procedure TfrmMain.PMouseMoveEcke(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var p : TPoint;
begin
  if not Flag then
    Exit;

  p := Point(pa.Left + X, pa.Top + Y);
  if Shift = [ssLeft] then
  begin
    pa.Left   := p.X - MPos.X;
    pa.Top    := p.Y - MPos.Y;
    pa.Width  := (p.X - MPos.X) - pa.Width;
  end;
end;

procedure TfrmMain.PMouseUpEcke(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Flag := False;
  with MPos do
  begin
    X := frmMain.Left + pa.Left;
    Y := frmMain.Top  + pa.Top;
  end;
end;

// Mitte
procedure TfrmMain.PMouseDownMitte(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ShowMessage('Down: Mitte');
end;

procedure TfrmMain.PMouseMoveMitte(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  //ShowMessage('Move: Mitte'); Wegen Nerverei deaktiviert....
end;

procedure TfrmMain.PMouseUpMitte(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ShowMessage('Up: Mitte');
end;

procedure TfrmMain.paMouseDown(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  MPos.X := X;
  MPos.Y := Y;
end;

procedure TfrmMain.FormPaint(Sender: TObject);
const Size : Integer = 8;
var i, j, ic, jc : Integer;
begin
  ic := Self.Height div Size;
  jc := Self.Width  div Size;
  for i := 0 to ic do
    for j := 0 to jc do
      Canvas.Pixels[j*Size, i*Size] := clBlack
end;

procedure TfrmMain.Button1Click(Sender: TObject);
  procedure ErstellePunkt(Le, T, Wi, He : Integer);
  var p : TPanel;  // Punkt = Panel
  begin
    inc(c);

    p := TPanel.Create(pa);
    with p do
    begin
      Parent     := pa;
      Left       := Le;
      Top        := T;
      Width      := Wi;
      Height     := He;
      BevelOuter := bvNone;
      Color      := clRed;
      if c in [1, 2, 3, 4] then
      begin
        OnMouseDown := PMouseDownEcke;
        OnMouseMove := PMouseMoveEcke;
        OnMouseUp   := PMouseUpEcke;
      end else
      begin
        OnMouseDown := PMouseDownMitte;
        OnMouseMove := PMouseMoveMitte;
        OnMouseUp   := PMouseUpMitte;
      end;
      Show;
    end;
  end;

  procedure ErstelleLinie(Le, T, Wi, He : Integer);
  var s : TShape;  // Punkt = Panel
  begin
    inc(c);
    s := TShape.Create(pa);
    with s do
    begin
      Parent     := pa;
      Left       := Le;
      Top        := T;
      Width      := Wi;
      Height     := He;
      BevelOuter := bvNone;
      Pen.Color  := clRed;
      OnMouseDown := PMouseDownMitte;
      OnMouseMove := PMouseMoveMitte;
      OnMouseUp   := PMouseUpMitte;
      Show;
    end;
  end;
var hh, hb : Integer; // hh=Halbe Höhe; hb=Halbe Breite
begin
  hh := pa.Height div 2;
  hb := pa.Width  div 2;
  // Skalierpunkte erstellen
  ErstellePunkt(0, 0, 5, 5);
  ErstellePunkt(pa.Width-5, 0, pa.Width, 5);
  ErstellePunkt(0, pa.Height-5, 5, pa.Height);
  ErstellePunkt(pa.Width-5, pa.Height-5, pa.Width, pa.Height);
  ErstellePunkt(0, hh-1, 5, 5);
  ErstellePunkt(pa.Width-5, hh-1, pa.Width, 5);
  ErstellePunkt(hb-1, 0, 5, 5);
  ErstellePunkt(hb-1, pa.Height-5, 5, pa.Height);
  // Skalierlinien erstellen
  ErstelleLinie(5, 2, pa.Width-10, 1);
  ErstelleLinie(5, pa.Height-3, pa.Width-10, 1);
  ErstelleLinie(2, 5, 1, pa.Height-10);
  ErstelleLinie(pa.Width-3, 5, 1, pa.Height-10);

end;

procedure TfrmMain.paMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer
  );
var p : TPoint;
begin
  p := Point(pa.Left + X, pa.Top + Y);
  if Shift = [ssLeft] then
  begin
    pa.Left := p.X - MPos.X;
    pa.Top  := p.Y - MPos.Y;
  end;
end;

procedure TfrmMain.paMouseUp(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  with MPos do
  begin
    X := frmMain.Left + pa.Left;
    Y := frmMain.Top  + pa.Top;
  end;
end;

initialization

{$I code.lrs}

end.

